Code

Merge branch 'jk/maint-mv'
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 unset VISUAL
46 unset EMAIL
47 unset $(perl -e '
48         my @env = keys %ENV;
49         my $ok = join("|", qw(
50                 TRACE
51                 DEBUG
52                 USE_LOOKUP
53                 TEST
54                 .*_TEST
55                 PROVE
56                 VALGRIND
57         ));
58         my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
59         print join("\n", @vars);
60 ')
61 GIT_AUTHOR_EMAIL=author@example.com
62 GIT_AUTHOR_NAME='A U Thor'
63 GIT_COMMITTER_EMAIL=committer@example.com
64 GIT_COMMITTER_NAME='C O Mitter'
65 GIT_MERGE_VERBOSITY=5
66 export GIT_MERGE_VERBOSITY
67 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
68 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
69 export EDITOR
71 # Protect ourselves from common misconfiguration to export
72 # CDPATH into the environment
73 unset CDPATH
75 unset GREP_OPTIONS
77 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
78         1|2|true)
79                 echo "* warning: Some tests will not work if GIT_TRACE" \
80                         "is set as to trace on STDERR ! *"
81                 echo "* warning: Please set GIT_TRACE to something" \
82                         "other than 1, 2 or true ! *"
83                 ;;
84 esac
86 # Convenience
87 #
88 # A regexp to match 5 and 40 hexdigits
89 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
90 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
92 # Zero SHA-1
93 _z40=0000000000000000000000000000000000000000
95 # Line feed
96 LF='
97 '
99 # Each test should start with something like this, after copyright notices:
101 # test_description='Description of this test...
102 # This test checks if command xyzzy does the right thing...
103 # '
104 # . ./test-lib.sh
105 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
106                 TERM=$ORIGINAL_TERM &&
107                 export TERM &&
108                 [ -t 1 ] &&
109                 tput bold >/dev/null 2>&1 &&
110                 tput setaf 1 >/dev/null 2>&1 &&
111                 tput sgr0 >/dev/null 2>&1
112         ) &&
113         color=t
115 while test "$#" -ne 0
116 do
117         case "$1" in
118         -d|--d|--de|--deb|--debu|--debug)
119                 debug=t; shift ;;
120         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
121                 immediate=t; shift ;;
122         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
123                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
124         -h|--h|--he|--hel|--help)
125                 help=t; shift ;;
126         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
127                 verbose=t; shift ;;
128         -q|--q|--qu|--qui|--quie|--quiet)
129                 # Ignore --quiet under a TAP::Harness. Saying how many tests
130                 # passed without the ok/not ok details is always an error.
131                 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
132         --with-dashes)
133                 with_dashes=t; shift ;;
134         --no-color)
135                 color=; shift ;;
136         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
137                 valgrind=t; verbose=t; shift ;;
138         --tee)
139                 shift ;; # was handled already
140         --root=*)
141                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
142                 shift ;;
143         *)
144                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
145         esac
146 done
148 if test -n "$color"; then
149         say_color () {
150                 (
151                 TERM=$ORIGINAL_TERM
152                 export TERM
153                 case "$1" in
154                         error) tput bold; tput setaf 1;; # bold red
155                         skip)  tput bold; tput setaf 2;; # bold green
156                         pass)  tput setaf 2;;            # green
157                         info)  tput setaf 3;;            # brown
158                         *) test -n "$quiet" && return;;
159                 esac
160                 shift
161                 printf "%s" "$*"
162                 tput sgr0
163                 echo
164                 )
165         }
166 else
167         say_color() {
168                 test -z "$1" && test -n "$quiet" && return
169                 shift
170                 echo "$*"
171         }
172 fi
174 error () {
175         say_color error "error: $*"
176         GIT_EXIT_OK=t
177         exit 1
180 say () {
181         say_color info "$*"
184 test "${test_description}" != "" ||
185 error "Test script did not set test_description."
187 if test "$help" = "t"
188 then
189         echo "$test_description"
190         exit 0
191 fi
193 exec 5>&1
194 if test "$verbose" = "t"
195 then
196         exec 4>&2 3>&1
197 else
198         exec 4>/dev/null 3>/dev/null
199 fi
201 test_failure=0
202 test_count=0
203 test_fixed=0
204 test_broken=0
205 test_success=0
207 test_external_has_tap=0
209 die () {
210         code=$?
211         if test -n "$GIT_EXIT_OK"
212         then
213                 exit $code
214         else
215                 echo >&5 "FATAL: Unexpected exit with code $code"
216                 exit 1
217         fi
220 GIT_EXIT_OK=
221 trap 'die' EXIT
223 # The semantics of the editor variables are that of invoking
224 # sh -c "$EDITOR \"$@\"" files ...
226 # If our trash directory contains shell metacharacters, they will be
227 # interpreted if we just set $EDITOR directly, so do a little dance with
228 # environment variables to work around this.
230 # In particular, quoting isn't enough, as the path may contain the same quote
231 # that we're using.
232 test_set_editor () {
233         FAKE_EDITOR="$1"
234         export FAKE_EDITOR
235         EDITOR='"$FAKE_EDITOR"'
236         export EDITOR
239 test_decode_color () {
240         awk '
241                 function name(n) {
242                         if (n == 0) return "RESET";
243                         if (n == 1) return "BOLD";
244                         if (n == 30) return "BLACK";
245                         if (n == 31) return "RED";
246                         if (n == 32) return "GREEN";
247                         if (n == 33) return "YELLOW";
248                         if (n == 34) return "BLUE";
249                         if (n == 35) return "MAGENTA";
250                         if (n == 36) return "CYAN";
251                         if (n == 37) return "WHITE";
252                         if (n == 40) return "BLACK";
253                         if (n == 41) return "BRED";
254                         if (n == 42) return "BGREEN";
255                         if (n == 43) return "BYELLOW";
256                         if (n == 44) return "BBLUE";
257                         if (n == 45) return "BMAGENTA";
258                         if (n == 46) return "BCYAN";
259                         if (n == 47) return "BWHITE";
260                 }
261                 {
262                         while (match($0, /\033\[[0-9;]*m/) != 0) {
263                                 printf "%s<", substr($0, 1, RSTART-1);
264                                 codes = substr($0, RSTART+2, RLENGTH-3);
265                                 if (length(codes) == 0)
266                                         printf "%s", name(0)
267                                 else {
268                                         n = split(codes, ary, ";");
269                                         sep = "";
270                                         for (i = 1; i <= n; i++) {
271                                                 printf "%s%s", sep, name(ary[i]);
272                                                 sep = ";"
273                                         }
274                                 }
275                                 printf ">";
276                                 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
277                         }
278                         print
279                 }
280         '
283 nul_to_q () {
284         perl -pe 'y/\000/Q/'
287 q_to_nul () {
288         perl -pe 'y/Q/\000/'
291 q_to_cr () {
292         tr Q '\015'
295 q_to_tab () {
296         tr Q '\011'
299 append_cr () {
300         sed -e 's/$/Q/' | tr Q '\015'
303 remove_cr () {
304         tr '\015' Q | sed -e 's/Q$//'
307 # In some bourne shell implementations, the "unset" builtin returns
308 # nonzero status when a variable to be unset was not set in the first
309 # place.
311 # Use sane_unset when that should not be considered an error.
313 sane_unset () {
314         unset "$@"
315         return 0
318 test_tick () {
319         if test -z "${test_tick+set}"
320         then
321                 test_tick=1112911993
322         else
323                 test_tick=$(($test_tick + 60))
324         fi
325         GIT_COMMITTER_DATE="$test_tick -0700"
326         GIT_AUTHOR_DATE="$test_tick -0700"
327         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
330 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
332 # This will commit a file with the given contents and the given commit
333 # message.  It will also add a tag with <message> as name.
335 # Both <file> and <contents> default to <message>.
337 test_commit () {
338         file=${2:-"$1.t"}
339         echo "${3-$1}" > "$file" &&
340         git add "$file" &&
341         test_tick &&
342         git commit -m "$1" &&
343         git tag "$1"
346 # Call test_merge with the arguments "<message> <commit>", where <commit>
347 # can be a tag pointing to the commit-to-merge.
349 test_merge () {
350         test_tick &&
351         git merge -m "$1" "$2" &&
352         git tag "$1"
355 # This function helps systems where core.filemode=false is set.
356 # Use it instead of plain 'chmod +x' to set or unset the executable bit
357 # of a file in the working directory and add it to the index.
359 test_chmod () {
360         chmod "$@" &&
361         git update-index --add "--chmod=$@"
364 # Unset a configuration variable, but don't fail if it doesn't exist.
365 test_unconfig () {
366         git config --unset-all "$@"
367         config_status=$?
368         case "$config_status" in
369         5) # ok, nothing to unset
370                 config_status=0
371                 ;;
372         esac
373         return $config_status
376 # Set git config, automatically unsetting it after the test is over.
377 test_config () {
378         test_when_finished "test_unconfig '$1'" &&
379         git config "$@"
382 test_config_global () {
383         test_when_finished "test_unconfig --global '$1'" &&
384         git config --global "$@"
387 # Use test_set_prereq to tell that a particular prerequisite is available.
388 # The prerequisite can later be checked for in two ways:
390 # - Explicitly using test_have_prereq.
392 # - Implicitly by specifying the prerequisite tag in the calls to
393 #   test_expect_{success,failure,code}.
395 # The single parameter is the prerequisite tag (a simple word, in all
396 # capital letters by convention).
398 test_set_prereq () {
399         satisfied="$satisfied$1 "
401 satisfied=" "
403 test_have_prereq () {
404         # prerequisites can be concatenated with ','
405         save_IFS=$IFS
406         IFS=,
407         set -- $*
408         IFS=$save_IFS
410         total_prereq=0
411         ok_prereq=0
412         missing_prereq=
414         for prerequisite
415         do
416                 total_prereq=$(($total_prereq + 1))
417                 case $satisfied in
418                 *" $prerequisite "*)
419                         ok_prereq=$(($ok_prereq + 1))
420                         ;;
421                 *)
422                         # Keep a list of missing prerequisites
423                         if test -z "$missing_prereq"
424                         then
425                                 missing_prereq=$prerequisite
426                         else
427                                 missing_prereq="$prerequisite,$missing_prereq"
428                         fi
429                 esac
430         done
432         test $total_prereq = $ok_prereq
435 test_declared_prereq () {
436         case ",$test_prereq," in
437         *,$1,*)
438                 return 0
439                 ;;
440         esac
441         return 1
444 # You are not expected to call test_ok_ and test_failure_ directly, use
445 # the text_expect_* functions instead.
447 test_ok_ () {
448         test_success=$(($test_success + 1))
449         say_color "" "ok $test_count - $@"
452 test_failure_ () {
453         test_failure=$(($test_failure + 1))
454         say_color error "not ok - $test_count $1"
455         shift
456         echo "$@" | sed -e 's/^/#       /'
457         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
460 test_known_broken_ok_ () {
461         test_fixed=$(($test_fixed+1))
462         say_color "" "ok $test_count - $@ # TODO known breakage"
465 test_known_broken_failure_ () {
466         test_broken=$(($test_broken+1))
467         say_color skip "not ok $test_count - $@ # TODO known breakage"
470 test_debug () {
471         test "$debug" = "" || eval "$1"
474 test_eval_ () {
475         # This is a separate function because some tests use
476         # "return" to end a test_expect_success block early.
477         eval >&3 2>&4 "$*"
480 test_run_ () {
481         test_cleanup=:
482         expecting_failure=$2
483         test_eval_ "$1"
484         eval_ret=$?
486         if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
487         then
488                 test_eval_ "$test_cleanup"
489         fi
490         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
491                 echo ""
492         fi
493         return "$eval_ret"
496 test_skip () {
497         test_count=$(($test_count+1))
498         to_skip=
499         for skp in $GIT_SKIP_TESTS
500         do
501                 case $this_test.$test_count in
502                 $skp)
503                         to_skip=t
504                         break
505                 esac
506         done
507         if test -z "$to_skip" && test -n "$test_prereq" &&
508            ! test_have_prereq "$test_prereq"
509         then
510                 to_skip=t
511         fi
512         case "$to_skip" in
513         t)
514                 of_prereq=
515                 if test "$missing_prereq" != "$test_prereq"
516                 then
517                         of_prereq=" of $test_prereq"
518                 fi
520                 say_color skip >&3 "skipping test: $@"
521                 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
522                 : true
523                 ;;
524         *)
525                 false
526                 ;;
527         esac
530 test_expect_failure () {
531         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
532         test "$#" = 2 ||
533         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
534         export test_prereq
535         if ! test_skip "$@"
536         then
537                 say >&3 "checking known breakage: $2"
538                 if test_run_ "$2" expecting_failure
539                 then
540                         test_known_broken_ok_ "$1"
541                 else
542                         test_known_broken_failure_ "$1"
543                 fi
544         fi
545         echo >&3 ""
548 test_expect_success () {
549         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
550         test "$#" = 2 ||
551         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
552         export test_prereq
553         if ! test_skip "$@"
554         then
555                 say >&3 "expecting success: $2"
556                 if test_run_ "$2"
557                 then
558                         test_ok_ "$1"
559                 else
560                         test_failure_ "$@"
561                 fi
562         fi
563         echo >&3 ""
566 # test_external runs external test scripts that provide continuous
567 # test output about their progress, and succeeds/fails on
568 # zero/non-zero exit code.  It outputs the test output on stdout even
569 # in non-verbose mode, and announces the external script with "# run
570 # <n>: ..." before running it.  When providing relative paths, keep in
571 # mind that all scripts run in "trash directory".
572 # Usage: test_external description command arguments...
573 # Example: test_external 'Perl API' perl ../path/to/test.pl
574 test_external () {
575         test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
576         test "$#" = 3 ||
577         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
578         descr="$1"
579         shift
580         export test_prereq
581         if ! test_skip "$descr" "$@"
582         then
583                 # Announce the script to reduce confusion about the
584                 # test output that follows.
585                 say_color "" "# run $test_count: $descr ($*)"
586                 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
587                 # to be able to use them in script
588                 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
589                 # Run command; redirect its stderr to &4 as in
590                 # test_run_, but keep its stdout on our stdout even in
591                 # non-verbose mode.
592                 "$@" 2>&4
593                 if [ "$?" = 0 ]
594                 then
595                         if test $test_external_has_tap -eq 0; then
596                                 test_ok_ "$descr"
597                         else
598                                 say_color "" "# test_external test $descr was ok"
599                                 test_success=$(($test_success + 1))
600                         fi
601                 else
602                         if test $test_external_has_tap -eq 0; then
603                                 test_failure_ "$descr" "$@"
604                         else
605                                 say_color error "# test_external test $descr failed: $@"
606                                 test_failure=$(($test_failure + 1))
607                         fi
608                 fi
609         fi
612 # Like test_external, but in addition tests that the command generated
613 # no output on stderr.
614 test_external_without_stderr () {
615         # The temporary file has no (and must have no) security
616         # implications.
617         tmp=${TMPDIR:-/tmp}
618         stderr="$tmp/git-external-stderr.$$.tmp"
619         test_external "$@" 4> "$stderr"
620         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
621         descr="no stderr: $1"
622         shift
623         say >&3 "# expecting no stderr from previous command"
624         if [ ! -s "$stderr" ]; then
625                 rm "$stderr"
627                 if test $test_external_has_tap -eq 0; then
628                         test_ok_ "$descr"
629                 else
630                         say_color "" "# test_external_without_stderr test $descr was ok"
631                         test_success=$(($test_success + 1))
632                 fi
633         else
634                 if [ "$verbose" = t ]; then
635                         output=`echo; echo "# Stderr is:"; cat "$stderr"`
636                 else
637                         output=
638                 fi
639                 # rm first in case test_failure exits.
640                 rm "$stderr"
641                 if test $test_external_has_tap -eq 0; then
642                         test_failure_ "$descr" "$@" "$output"
643                 else
644                         say_color error "# test_external_without_stderr test $descr failed: $@: $output"
645                         test_failure=$(($test_failure + 1))
646                 fi
647         fi
650 # debugging-friendly alternatives to "test [-f|-d|-e]"
651 # The commands test the existence or non-existence of $1. $2 can be
652 # given to provide a more precise diagnosis.
653 test_path_is_file () {
654         if ! [ -f "$1" ]
655         then
656                 echo "File $1 doesn't exist. $*"
657                 false
658         fi
661 test_path_is_dir () {
662         if ! [ -d "$1" ]
663         then
664                 echo "Directory $1 doesn't exist. $*"
665                 false
666         fi
669 test_path_is_missing () {
670         if [ -e "$1" ]
671         then
672                 echo "Path exists:"
673                 ls -ld "$1"
674                 if [ $# -ge 1 ]; then
675                         echo "$*"
676                 fi
677                 false
678         fi
681 # test_line_count checks that a file has the number of lines it
682 # ought to. For example:
684 #       test_expect_success 'produce exactly one line of output' '
685 #               do something >output &&
686 #               test_line_count = 1 output
687 #       '
689 # is like "test $(wc -l <output) = 1" except that it passes the
690 # output through when the number of lines is wrong.
692 test_line_count () {
693         if test $# != 3
694         then
695                 error "bug in the test script: not 3 parameters to test_line_count"
696         elif ! test $(wc -l <"$3") "$1" "$2"
697         then
698                 echo "test_line_count: line count for $3 !$1 $2"
699                 cat "$3"
700                 return 1
701         fi
704 # This is not among top-level (test_expect_success | test_expect_failure)
705 # but is a prefix that can be used in the test script, like:
707 #       test_expect_success 'complain and die' '
708 #           do something &&
709 #           do something else &&
710 #           test_must_fail git checkout ../outerspace
711 #       '
713 # Writing this as "! git checkout ../outerspace" is wrong, because
714 # the failure could be due to a segv.  We want a controlled failure.
716 test_must_fail () {
717         "$@"
718         exit_code=$?
719         if test $exit_code = 0; then
720                 echo >&2 "test_must_fail: command succeeded: $*"
721                 return 1
722         elif test $exit_code -gt 129 -a $exit_code -le 192; then
723                 echo >&2 "test_must_fail: died by signal: $*"
724                 return 1
725         elif test $exit_code = 127; then
726                 echo >&2 "test_must_fail: command not found: $*"
727                 return 1
728         fi
729         return 0
732 # Similar to test_must_fail, but tolerates success, too.  This is
733 # meant to be used in contexts like:
735 #       test_expect_success 'some command works without configuration' '
736 #               test_might_fail git config --unset all.configuration &&
737 #               do something
738 #       '
740 # Writing "git config --unset all.configuration || :" would be wrong,
741 # because we want to notice if it fails due to segv.
743 test_might_fail () {
744         "$@"
745         exit_code=$?
746         if test $exit_code -gt 129 -a $exit_code -le 192; then
747                 echo >&2 "test_might_fail: died by signal: $*"
748                 return 1
749         elif test $exit_code = 127; then
750                 echo >&2 "test_might_fail: command not found: $*"
751                 return 1
752         fi
753         return 0
756 # Similar to test_must_fail and test_might_fail, but check that a
757 # given command exited with a given exit code. Meant to be used as:
759 #       test_expect_success 'Merge with d/f conflicts' '
760 #               test_expect_code 1 git merge "merge msg" B master
761 #       '
763 test_expect_code () {
764         want_code=$1
765         shift
766         "$@"
767         exit_code=$?
768         if test $exit_code = $want_code
769         then
770                 return 0
771         fi
773         echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
774         return 1
777 # test_cmp is a helper function to compare actual and expected output.
778 # You can use it like:
780 #       test_expect_success 'foo works' '
781 #               echo expected >expected &&
782 #               foo >actual &&
783 #               test_cmp expected actual
784 #       '
786 # This could be written as either "cmp" or "diff -u", but:
787 # - cmp's output is not nearly as easy to read as diff -u
788 # - not all diff versions understand "-u"
790 test_cmp() {
791         $GIT_TEST_CMP "$@"
794 # This function can be used to schedule some commands to be run
795 # unconditionally at the end of the test to restore sanity:
797 #       test_expect_success 'test core.capslock' '
798 #               git config core.capslock true &&
799 #               test_when_finished "git config --unset core.capslock" &&
800 #               hello world
801 #       '
803 # That would be roughly equivalent to
805 #       test_expect_success 'test core.capslock' '
806 #               git config core.capslock true &&
807 #               hello world
808 #               git config --unset core.capslock
809 #       '
811 # except that the greeting and config --unset must both succeed for
812 # the test to pass.
814 # Note that under --immediate mode, no clean-up is done to help diagnose
815 # what went wrong.
817 test_when_finished () {
818         test_cleanup="{ $*
819                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
822 # Most tests can use the created repository, but some may need to create more.
823 # Usage: test_create_repo <directory>
824 test_create_repo () {
825         test "$#" = 1 ||
826         error "bug in the test script: not 1 parameter to test-create-repo"
827         repo="$1"
828         mkdir -p "$repo"
829         (
830                 cd "$repo" || error "Cannot setup test environment"
831                 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
832                 error "cannot run git init -- have you built things yet?"
833                 mv .git/hooks .git/hooks-disabled
834         ) || exit
837 test_done () {
838         GIT_EXIT_OK=t
840         if test -z "$HARNESS_ACTIVE"; then
841                 test_results_dir="$TEST_DIRECTORY/test-results"
842                 mkdir -p "$test_results_dir"
843                 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
845                 cat >>"$test_results_path" <<-EOF
846                 total $test_count
847                 success $test_success
848                 fixed $test_fixed
849                 broken $test_broken
850                 failed $test_failure
852                 EOF
853         fi
855         if test "$test_fixed" != 0
856         then
857                 say_color pass "# fixed $test_fixed known breakage(s)"
858         fi
859         if test "$test_broken" != 0
860         then
861                 say_color error "# still have $test_broken known breakage(s)"
862                 msg="remaining $(($test_count-$test_broken)) test(s)"
863         else
864                 msg="$test_count test(s)"
865         fi
866         case "$test_failure" in
867         0)
868                 # Maybe print SKIP message
869                 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
871                 if test $test_external_has_tap -eq 0; then
872                         say_color pass "# passed all $msg"
873                         say "1..$test_count$skip_all"
874                 fi
876                 test -d "$remove_trash" &&
877                 cd "$(dirname "$remove_trash")" &&
878                 rm -rf "$(basename "$remove_trash")"
880                 exit 0 ;;
882         *)
883                 if test $test_external_has_tap -eq 0; then
884                         say_color error "# failed $test_failure among $msg"
885                         say "1..$test_count"
886                 fi
888                 exit 1 ;;
890         esac
893 # Test the binaries we have just built.  The tests are kept in
894 # t/ subdirectory and are run in 'trash directory' subdirectory.
895 if test -z "$TEST_DIRECTORY"
896 then
897         # We allow tests to override this, in case they want to run tests
898         # outside of t/, e.g. for running tests on the test library
899         # itself.
900         TEST_DIRECTORY=$(pwd)
901 fi
902 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
904 if test -n "$valgrind"
905 then
906         make_symlink () {
907                 test -h "$2" &&
908                 test "$1" = "$(readlink "$2")" || {
909                         # be super paranoid
910                         if mkdir "$2".lock
911                         then
912                                 rm -f "$2" &&
913                                 ln -s "$1" "$2" &&
914                                 rm -r "$2".lock
915                         else
916                                 while test -d "$2".lock
917                                 do
918                                         say "Waiting for lock on $2."
919                                         sleep 1
920                                 done
921                         fi
922                 }
923         }
925         make_valgrind_symlink () {
926                 # handle only executables, unless they are shell libraries that
927                 # need to be in the exec-path.  We will just use "#!" as a
928                 # guess for a shell-script, since we have no idea what the user
929                 # may have configured as the shell path.
930                 test -x "$1" ||
931                 test "#!" = "$(head -c 2 <"$1")" ||
932                 return;
934                 base=$(basename "$1")
935                 symlink_target=$GIT_BUILD_DIR/$base
936                 # do not override scripts
937                 if test -x "$symlink_target" &&
938                     test ! -d "$symlink_target" &&
939                     test "#!" != "$(head -c 2 < "$symlink_target")"
940                 then
941                         symlink_target=../valgrind.sh
942                 fi
943                 case "$base" in
944                 *.sh|*.perl)
945                         symlink_target=../unprocessed-script
946                 esac
947                 # create the link, or replace it if it is out of date
948                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
949         }
951         # override all git executables in TEST_DIRECTORY/..
952         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
953         mkdir -p "$GIT_VALGRIND"/bin
954         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
955         do
956                 make_valgrind_symlink $file
957         done
958         # special-case the mergetools loadables
959         make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
960         OLDIFS=$IFS
961         IFS=:
962         for path in $PATH
963         do
964                 ls "$path"/git-* 2> /dev/null |
965                 while read file
966                 do
967                         make_valgrind_symlink "$file"
968                 done
969         done
970         IFS=$OLDIFS
971         PATH=$GIT_VALGRIND/bin:$PATH
972         GIT_EXEC_PATH=$GIT_VALGRIND/bin
973         export GIT_VALGRIND
974 elif test -n "$GIT_TEST_INSTALLED" ; then
975         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
976         error "Cannot run git from $GIT_TEST_INSTALLED."
977         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
978         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
979 else # normal case, use ../bin-wrappers only unless $with_dashes:
980         git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
981         if ! test -x "$git_bin_dir/git" ; then
982                 if test -z "$with_dashes" ; then
983                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
984                 fi
985                 with_dashes=t
986         fi
987         PATH="$git_bin_dir:$PATH"
988         GIT_EXEC_PATH=$GIT_BUILD_DIR
989         if test -n "$with_dashes" ; then
990                 PATH="$GIT_BUILD_DIR:$PATH"
991         fi
992 fi
993 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
994 unset GIT_CONFIG
995 GIT_CONFIG_NOSYSTEM=1
996 GIT_ATTR_NOSYSTEM=1
997 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
999 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
1001 if test -z "$GIT_TEST_CMP"
1002 then
1003         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1004         then
1005                 GIT_TEST_CMP="$DIFF -c"
1006         else
1007                 GIT_TEST_CMP="$DIFF -u"
1008         fi
1009 fi
1011 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
1012 export GITPERLLIB
1013 test -d "$GIT_BUILD_DIR"/templates/blt || {
1014         error "You haven't built things yet, have you?"
1017 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
1018 then
1019         GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
1020         export GITPYTHONLIB
1021         test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
1022                 error "You haven't built git_remote_helpers yet, have you?"
1023         }
1024 fi
1026 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
1027         echo >&2 'You need to build test-chmtime:'
1028         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
1029         exit 1
1030 fi
1032 # Test repository
1033 test="trash directory.$(basename "$0" .sh)"
1034 test -n "$root" && test="$root/$test"
1035 case "$test" in
1036 /*) TRASH_DIRECTORY="$test" ;;
1037  *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1038 esac
1039 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
1040 rm -fr "$test" || {
1041         GIT_EXIT_OK=t
1042         echo >&5 "FATAL: Cannot prepare test area"
1043         exit 1
1046 HOME="$TRASH_DIRECTORY"
1047 export HOME
1049 test_create_repo "$test"
1050 # Use -P to resolve symlinks in our working directory so that the cwd
1051 # in subprocesses like git equals our $PWD (for pathname comparisons).
1052 cd -P "$test" || exit 1
1054 this_test=${0##*/}
1055 this_test=${this_test%%-*}
1056 for skp in $GIT_SKIP_TESTS
1057 do
1058         case "$this_test" in
1059         $skp)
1060                 say_color skip >&3 "skipping test $this_test altogether"
1061                 skip_all="skip all tests in $this_test"
1062                 test_done
1063         esac
1064 done
1066 # Provide an implementation of the 'yes' utility
1067 yes () {
1068         if test $# = 0
1069         then
1070                 y=y
1071         else
1072                 y="$*"
1073         fi
1075         while echo "$y"
1076         do
1077                 :
1078         done
1081 # Fix some commands on Windows
1082 case $(uname -s) in
1083 *MINGW*)
1084         # Windows has its own (incompatible) sort and find
1085         sort () {
1086                 /usr/bin/sort "$@"
1087         }
1088         find () {
1089                 /usr/bin/find "$@"
1090         }
1091         sum () {
1092                 md5sum "$@"
1093         }
1094         # git sees Windows-style pwd
1095         pwd () {
1096                 builtin pwd -W
1097         }
1098         # no POSIX permissions
1099         # backslashes in pathspec are converted to '/'
1100         # exec does not inherit the PID
1101         test_set_prereq MINGW
1102         test_set_prereq SED_STRIPS_CR
1103         ;;
1104 *CYGWIN*)
1105         test_set_prereq POSIXPERM
1106         test_set_prereq EXECKEEPSPID
1107         test_set_prereq NOT_MINGW
1108         test_set_prereq SED_STRIPS_CR
1109         ;;
1110 *)
1111         test_set_prereq POSIXPERM
1112         test_set_prereq BSLASHPSPEC
1113         test_set_prereq EXECKEEPSPID
1114         test_set_prereq NOT_MINGW
1115         ;;
1116 esac
1118 test -z "$NO_PERL" && test_set_prereq PERL
1119 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1120 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
1122 # Can we rely on git's output in the C locale?
1123 if test -n "$GETTEXT_POISON"
1124 then
1125         GIT_GETTEXT_POISON=YesPlease
1126         export GIT_GETTEXT_POISON
1127 else
1128         test_set_prereq C_LOCALE_OUTPUT
1129 fi
1131 # Use this instead of test_cmp to compare files that contain expected and
1132 # actual output from git commands that can be translated.  When running
1133 # under GETTEXT_POISON this pretends that the command produced expected
1134 # results.
1135 test_i18ncmp () {
1136         test -n "$GETTEXT_POISON" || test_cmp "$@"
1139 # Use this instead of "grep expected-string actual" to see if the
1140 # output from a git command that can be translated either contains an
1141 # expected string, or does not contain an unwanted one.  When running
1142 # under GETTEXT_POISON this pretends that the command produced expected
1143 # results.
1144 test_i18ngrep () {
1145         if test -n "$GETTEXT_POISON"
1146         then
1147             : # pretend success
1148         elif test "x!" = "x$1"
1149         then
1150                 shift
1151                 ! grep "$@"
1152         else
1153                 grep "$@"
1154         fi
1157 # test whether the filesystem supports symbolic links
1158 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1159 rm -f y
1161 # When the tests are run as root, permission tests will report that
1162 # things are writable when they shouldn't be.
1163 test -w / || test_set_prereq SANITY